---
title: IDBObjectStore.createIndex()
slug: Web/API/IDBObjectStore/createIndex
tags:
  - API
  - Database
  - IDBObjectStore
  - IndexedDB
  - Method
  - Reference
  - Storage
  - createIndex
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>createIndex()</code></strong> method of the {{domxref("IDBObjectStore")}} interface creates and returns a new {{domxref("IDBIndex")}} object in the connected database. It creates a new field/column defining a new data point for each database record to contain.</p>

<p>Bear in mind that IndexedDB indexes can contain <em>any</em> JavaScript data type; IndexedDB uses the <a href="/en-US/docs/Web/API/Web_Workers_API/Structured_clone_algorithm">structured clone algorithm</a> to serialize stored objects, which allows for storage of simple and complex objects.</p>
</div>

<p>Note that this method must be called only from a <code>VersionChange</code> transaction mode callback.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox" style="font-size: 14px;">var <em>myIDBIndex</em> = <em>objectStore</em>.createIndex(<em>indexName</em>, <em>keyPath</em>);
var <em>myIDBIndex</em> = <em>objectStore</em>.createIndex(<em>indexName</em>, <em>keyPath</em>, <em>objectParameters</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>indexName</dt>
 <dd>The name of the index to create. Note that it is possible to create an index with an empty name.</dd>
 <dt>keyPath</dt>
 <dd>The key path for the index to use. Note that it is possible to create an index with an empty <code>keyPath</code>, and also to pass in a sequence (array) as a <code>keyPath</code>.</dd>
 <dt>objectParameters {{optional_inline}}</dt>
 <dd>
 <p>An {{domxref("IDBIndexParameters")}} object, which can include the following properties:</p>

 <table class="standard-table">
  <thead>
   <tr>
    <th scope="col">Attribute</th>
    <th scope="col">Description</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td><code>unique</code></td>
    <td>If true, the index will not allow duplicate values for a single key.</td>
   </tr>
   <tr>
    <td><code>multiEntry</code></td>
    <td>If <code>true</code>, the index will add an entry in the index for each array element when the <em>keyPath</em> resolves to an Array. If <code>false</code>, it will add one single entry containing the Array.</td>
   </tr>
   <tr>
    <td><code>locale</code></td>
    <td>
     <p>Currently Firefox-only (43+), this allows you to specify a locale for the index. Any sorting operations performed on the data via key ranges will then obey sorting rules of that locale (see <a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB#Locale-aware_sorting">locale-aware sorting</a>.) You can specify its value in one of three ways:</p>

     <ul>
      <li><code>string</code>: A string containing a specific locale code, e.g. <code>en-US</code>, or <code>pl</code>.</li>
      <li><code>auto</code>: The platform default locale will be used (may be changed by user agent settings.)</li>
      <li><code>null or undefined</code>: If no locale is specified, normal JavaScript sorting will be used — not locale-aware.</li>
     </ul>
    </td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><span style="line-height: 1.5;">An {{domxref("IDBIndex")}} object: the newly created index.</span></p>

<h3 id="Exceptions"><span style="line-height: 1.5;">Exceptions</span></h3>

<p><span style="line-height: 1.5;">This method may raise a {{domxref("DOMException")}} of one of the following types:</span></p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>ConstraintError</code></td>
   <td>Occurs if an index with the same name already exists in the database. Index names are case-sensitive.</td>
  </tr>
  <tr>
   <td><code>InvalidAccessError</code></td>
   <td>Occurs if the provided key path is a sequence, and <code>multiEntry</code> is set to <code>true</code> in the <code>objectParameters</code> object.</td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>
    <p>Occurs if either:</p>

    <ul>
     <li>The method was not called from a <code>versionchange</code> transaction mode callback, i.e. from inside a {{domxref("IDBOpenDBRequest.onupgradeneeded")}} handler.</li>
     <li>The object store has been deleted.</li>
    </ul>
   </td>
  </tr>
  <tr>
   <td><code>SyntaxError</code></td>
   <td>Occurs if the provided <code>keyPath</code> is not a <a href="https://www.w3.org/TR/IndexedDB/#dfn-valid-key-path">valid key path</a>.</td>
  </tr>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>Occurs if the transaction this {{domxref("IDBObjectStore")}} belongs to is not active (e.g. has been deleted or removed.) In Firefox previous to version 41, an <code>InvalidStateError</code> was raised in this case as well, which was misleading; this has now been fixed (see {{Bug("1176165")}}.)</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In the following example you can see the {{domxref("IDBOpenDBRequest.onupgradeneeded")}} handler being used to update the database structure if a database with a higher version number is loaded. <code>createIndex()</code> is used to create new indexes on the object store.  For a full working example, see our <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> app (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</p>

<pre class="brush: js">var db;

// Let us open our database
var DBOpenRequest = window.indexedDB.open("toDoList", 4);

// Two event handlers for opening the database.
DBOpenRequest.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
};

DBOpenRequest.onsuccess = function(event) {
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';

  // store the result of opening the database in the db variable.
  // This is used a lot below.
  db = request.result;

  // Run the displayData() function to populate the task list with
  // all the to-do list data already in the IDB
  displayData();
};

// This handler fires when a new database is created and indicates
// either that one has not been created before, or a new version
// was submitted with window.indexedDB.open(). (See above.)
// It is only implemented in recent browsers.
DBOpenRequest.onupgradeneeded = function(event) {
  var db = event.target.result;

  db.onerror = function(event) {
    note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
  };

  // Create an objectStore for this database
  var objectStore = db.createObjectStore("toDoList", { keyPath: "taskTitle" });

  // define what data items the objectStore will contain

  objectStore.createIndex("hours", "hours", { unique: false });
  objectStore.createIndex("minutes", "minutes", { unique: false });
  objectStore.createIndex("day", "day", { unique: false });
  objectStore.createIndex("month", "month", { unique: false });
  objectStore.createIndex("year", "year", { unique: false });
  objectStore.createIndex("notified", "notified", { unique: false });
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbobjectstore-createindex', 'createIndex()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbobjectstore-createindex", "createIndex()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBObjectStore.createIndex")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
